#include <stdio.h>

#include "event_loop.h"
#include "log.h"

int main() {
  setvbuf(stdout, NULL, _IONBF, 0);

  info("Initializing trie");

  Trie *trie = trie_init();
  int count = trie_populate(trie, "lander.data");

  if (count < 0) {
    critical(1, "An error occured while populating the trie.");
  }

  info("Trie initialized and populated with %i entries", count);

  event_loop_gctx *gctx = event_loop_gctx_init();
  gctx->trie = trie;
  event_loop *el = event_loop_init(gctx);

  event_loop_run(el, 8000);
}
